#include"bitmap.h"
#include<stdlib.h>
#include<stdio.h>
#include"calculation.h"

int main(int argc, char *argv[])
{
	double *re, *im;

	if(argc != 3){
		fprintf(stderr, "Usage: program <inputfile> <outputfile>\n");
		exit(1);
	}

	Image *colorimg;

	if((colorimg = Read_Bmp(argv[1])) == NULL){
		exit(1);
	}

	Grayscale(colorimg);

	if((re = (double*)malloc(sizeof(double)*colorimg->width*colorimg->height)) == NULL){
		fprintf(stderr, "Allocationerror\n");
		exit(1);
	}

	if((im = (double*)malloc(sizeof(double)*colorimg->width*colorimg->height)) == NULL){
		fprintf(stderr, "Allocationerror\n");
		exit(1);
	}

  RgbFrequencyTrans(colorimg, re, im, DFT);

	RgbFrequencyTrans(colorimg, re, im, IDFT);


	free(re);
	free(im);

	if(Write_Bmp(argv[2], colorimg)){
		exit(1);
	}

	Free_Image(colorimg);

	return 0;
}

